#include <iostream>
using namespace std;

#define DECKSIZE 52

void initialize_deck(int d[])
{
    for (int i = 0; i < DECKSIZE; i++)
        d[i] = i;
}

void shuffle(int d[])
{
    cout << endl << "Shuffling" << endl;
    int temp_deck[DECKSIZE]; // array to hold result
    for (int i = 0; i < DECKSIZE; i++)
        temp_deck[i] = d[i]; // lift the cards off the table, a.k.a. put them in a temporary buffer

    for (int i = 0; i < DECKSIZE; i++)
    {
        if (i % 2 == 0)
            d[i] = temp_deck[i/2]; // Pick from first side
        else
            d[i] = temp_deck[(i-1)/2 + DECKSIZE/2]; // Pick from second side
    }
}

void print_deck(int d[])
{
    for (int i = 0; i < DECKSIZE; i++)
        cout << "[" << i << "]  = " << d[i] << endl;
}

bool in_order(int d[])
{
    // Check that every pair in the array is in increasing order
    for (int i = 0; i < DECKSIZE-1; i++)
        if (d[i+1] <= d[i]) 
            return false;
    return true;
}

int main()
{
    int deck[DECKSIZE]; 
    initialize_deck(deck);

    cout << "Before: " << endl;
    //print_deck(deck);
    if (in_order(deck))
        cout << "\t Deck starts in order." << endl;

    for (int n = 0; n < 8; n++)
    {
        shuffle(deck);
        if (!in_order(deck))
            cout << "\t Deck not in order now." << endl;
    }
    

    cout << endl << "Afterwards : " << endl;
    //print_deck(deck);
    if (in_order(deck))
        cout << "\t Deck in order at end." << endl;

    return 0;
}
